import java.sql.*;

public class BatchDeadLock {

	public static void main(String args[]) throws Exception {
		Class.forName("org.postgresql.Driver");
		Connection conn = DriverManager.getConnection("jdbc:postgresql://localhost:5830/jurka?loglevel=2", "jurka", "");

		StringBuffer create = new StringBuffer("CREATE TEMP TABLE largetable (");
		StringBuffer insert = new StringBuffer("INSERT INTO largetable VALUES (");
		int numParams = 500;
		int batchSize = 250;
		for (int i=0; i<numParams; i++) {
			if (i != 0) {
				create.append(", ");
				insert.append(", ");
			}
			create.append("a").append(i).append(" int");
			insert.append("?");
		}
		create.append(")");
		insert.append(")");

		Statement stmt = conn.createStatement();
		stmt.execute(create.toString());

		PreparedStatement pstmt = conn.prepareStatement(insert.toString());
		for (int i=0; i<batchSize; i++) {
			for (int j=0; j<numParams; j++) {
				int counter = (i+j) % 2;
				if (counter == 0) {
					pstmt.setInt(j+1, 1);
				} else {
					pstmt.setObject(j+1, new Integer(1), Types.OTHER);
				}
			}
			pstmt.addBatch();
		}

		pstmt.executeBatch();
		conn.close();
	}
}
